%% Get all defined properties 
prop.m_b = 3e-3; %mass of ball [kg] 
prop.R_b = 16.55e-3; %ball radius [m] 
prop.r_f = 12.5e-3; %distance between plates [m] 
prop.R = sqrt(prop.R_b^2 - prop.r_f^2); %effective rolling radius [m] 
prop.J_b = 5.48e-7; %moment of inertia of ball [kg*m^2] 
prop.J_f = 1.581e-3; %moment of inertia of the frame [kg*m^2] 
prop.grav = [0; 9.81; 0]; %gravitational acceleration [m*s^2] 
prop.a = 0.1095; %bf frame
prop.b = 0.0405; %bf frame 
prop.c = 0.49; %VHC parameter 0.49 ORIGINALLY 
prop.k_hat = [0; 0; 1]; %z-axis (rotation) 
prop.B = [1;0]; %Coupling matrix 
prop.B_an = [0 1]; %Annihalitor matrix 
prop.I = eye(3); %3x3 identity matrix 
prop.Q = [0 1 0; -1 0 0; 0 0 0]; %Matrix used for differentiation

