prop.m_b = 3e-3; %mass of ball [kg] 
prop.R_b = 16.55e-3; %ball radius [m] 
prop.r_f = 12.5e-3; %distance between plates [m] 
prop.R = sqrt(prop.R_b^2 - prop.r_f^2); %effective rolling radius [m] 
prop.J_b = 5.48e-7; %moment of inertia of ball [kg*m^2] 
prop.J_f = 1.581e-3; %moment of inertia of the frame [kg*m^2] 
prop.grav = [0; 9.81; 0]; %gravitational acceleration [m*s^2] 
prop.a = 0.1095; %bf frame
prop.b = 0.0405; %bf frame 
prop.c = 0.49; %VHC parameter 
prop.k_hat = [0; 0; 1]; %z-axis (rotation) 
prop.B = [1;0]; %Coupling matrix 
prop.B_an = [0 1]; %Annihalitor matrix 
prop.I = eye(3); %3x3 identity matrix 
prop.Q = [0 1 0; -1 0 0; 0 0 0]; %Matrix used for differentiation

N = 100; a_phi = linspace(0,2*pi,N); %phi array 
varphis = linspace(0,2*pi,N);
Alphas=zeros(1,N); %%%%%%%
g=zeros(1,N); 
d_Thectas=zeros(1,N);%%%%%%%
d_ThectasINV=zeros(1,N);%%%%%%%
Gammas=zeros(1,N);%%%%%%%
Betas=zeros(1,N);%%%%%%%
factor1=zeros(1,N);%%%%%%%
factor2=zeros(1,N);%%%%%%%
factor3=zeros(1,N);%%%%%%%
factor4=zeros(1,N);%%%%%%%
factor5=zeros(1,4);%%%%%%%
for i = 1:N 
phi = a_phi(i); 
delta = prop.a-prop.b*cos(2*phi); 
d_delta = 2*prop.b*sin(2*phi); 
alpha = atan((delta*sin(phi)-d_delta*cos(phi))/(delta*cos(phi)+d_delta*sin(phi))); 

if phi > 0.5*pi && phi < 1.5*pi %%between 90 and 270 degrees
    alpha = alpha+pi; %%si no dara negativos.
elseif phi >= 1.5*pi 
  alpha = alpha+2*pi; %%si no dara negativos.
end

g(i) = atan2(delta*sin(phi)+prop.R*sin(alpha),delta*cos(phi)+prop.R*cos(alpha));
end 
g = mod(g,2*pi); %%divide todo el vector entre 2*pi y saca todos los restos 
g = unwrap(g*2)/2; %%obtiene todos los g's desde 0 hasta 2*pi
prop.phi_app = spline(g,a_phi); %save in struct par , to access it in simulation

for i = 1:N
    varphi=varphis(i);
    phi = ppval(prop.phi_app ,varphi); %read out spline: phi = f(varphi)

delta = prop.a-prop.b*cos(2*phi); 
d_delta = 2*prop.b*sin(2*phi); 
dd_delta = 4*prop.b*cos(2*phi); 
ddd_delta = -8*prop.b*sin(2*phi);

xi = [sin(phi); cos(phi);0]; 
delta_vec = delta*xi; 
d_delta_vec = (d_delta*prop.I + delta*prop.Q)*xi; 
dd_delta_vec = (dd_delta*prop.I + 2*d_delta*prop.Q - delta*prop.I)*xi;

alpha = atan( (delta*sin(phi) - d_delta*cos(phi)) / (delta*cos(phi) + d_delta*sin(phi))); 
if phi > 0.5*pi && phi < 1.5*pi 
    alpha = alpha+pi; 
elseif phi >= 1.5*pi 
    alpha = alpha+2*pi; 
end
%%%%pag44 explained 
d_alpha = (2*d_delta^2 + delta^2 - dd_delta*delta)/(d_delta^2 + delta^2); 
dd_alpha = (2*delta*d_delta -delta*ddd_delta+3*d_delta*dd_delta)/(delta^2+d_delta^2) -(2*d_delta*(delta+dd_delta)*(delta^2-delta*dd_delta+2*d_delta^2))/((delta^2+d_delta^2)^2);

v1 = prop.R^2*dd_alpha+delta*(prop.R*sin(phi-alpha)+prop.R*sin(phi-alpha)*d_alpha^2+prop.R*cos(phi-alpha)*dd_alpha - 2*prop.R*sin(phi-alpha)*d_alpha)+prop.R*sin(phi-alpha)*dd_delta; 
v2 = delta^2 + prop.R^2+2*prop.R*cos(phi-alpha)*delta; 
v3 = (2*delta*d_delta+2*prop.R*cos(phi-alpha)*d_delta+2*prop.R*sin(phi-alpha)*delta*(d_alpha -1))*(prop.R^2*d_alpha -prop.R^2+prop.R*sin(phi-alpha)*d_delta+prop.R*cos(phi-alpha)*delta*(d_alpha -1)); 
v4 = v2^2; 
g = atan2(delta*sin(phi)+prop.R*sin(alpha),delta*cos(phi)+prop.R*cos(alpha)); 
d_g = (delta^2+prop.R^2*d_alpha+prop.R*delta*cos(phi-alpha)+prop.R*d_delta*sin(phi-alpha)+prop.R*d_alpha*delta*cos(phi-alpha))/v2; 
dd_g = v1/v2 - v3/v4;

n = [sin(alpha); cos(alpha);0];
d_n = [cos(alpha); -sin(alpha);0]*d_alpha; 
dd_n = [-sin(alpha)*d_alpha^2+cos(alpha)*dd_alpha; -cos(alpha)*d_alpha^2-sin(alpha)*dd_alpha;0];
%%%%%

rho = delta_vec + prop.R*n; 
h = d_delta_vec + prop.R*d_n; 
d_h = dd_delta_vec + prop.R*dd_n; 
tau = d_delta_vec/norm(d_delta_vec);
%%%%%

kappa_f = norm(cross(d_delta_vec ,dd_delta_vec))/(norm(d_delta_vec)^3); 
kappa_c = kappa_f/(1-prop.R*kappa_f); 
kappa = kappa_c*n;

p = 1/(prop.R*(prop.R*kappa_f -1));

d_s = norm(h)/d_g; 
dd_s = dot(h,d_h)/(norm(h)*d_g^2) - norm(h)*dd_g/(d_g^3);
%%
%%
prop.c=0.1;
Theta = varphi-pi+prop.c*sin(2*varphi); %%%%%   VHC   %%%%%
d_Theta = 1+2*prop.c*cos(2*varphi); 
dd_Theta = -4*prop.c*sin(2*varphi);

%%%%Theta = varphi +prop.c*cos(varphi); %%%%%   VHC   %%%%%
%%%%d_Theta = 1-prop.c*sin(varphi); 
%%%%dd_Theta = -prop.c*cos(varphi);

%Theta = varphi -prop.c*sin(2*varphi); %%%%%   VHC   %%%%%
%d_Theta = 1-2*prop.c*cos(2*varphi); 
%dd_Theta = 4*prop.c*sin(2*varphi);

%%%Theta =varphi+prop.c*sin(cos(varphi)*varphi); %%%%%   VHC   %%%%%
%%%d_Theta = 1+prop.c*(cos(varphi)-varphi*sin(varphi))*cos(cos(varphi)*varphi); 
%%%dd_Theta =prop.c*(-sin(varphi)-(sin(varphi)+varphi*cos(varphi)))*cos(cos(varphi)*varphi) +  (cos(varphi)-varphi*sin(varphi))* (cos(varphi)-varphi*sin(varphi)*-sin(cos(varphi)*varphi));

%%Theta =varphi+0.23*sin(varphi)*(pi/2-varphi)*(3*pi/2-varphi); %%%%%   VHC   %%%%%
%%d_Theta =1+0.23*(cos(varphi)*((pi/2-varphi)*(3*pi/2-varphi))-1*(sin(varphi)*(3*pi/2-varphi))-1*(sin(varphi)*(pi/2-varphi)));
%%dd_Theta =0.23*(-sin(varphi)*((pi/2-varphi)*(3*pi/2-varphi))-1*(cos(varphi)*(3*pi/2-varphi))-1*(cos(varphi)*((pi/2-varphi))  -   (cos(varphi)*(3*pi/2-varphi)-1*sin(varphi))  -  (cos(varphi)*(pi/2-varphi)-1*sin(varphi))));
%%
%%
if varphi==pi 
    factor5(1)=sin(Theta);
elseif varphi==2*pi
    factor5(2)=sin(Theta);
elseif varphi==pi/2
    factor5(3)=cos(Theta);
elseif varphi==3*pi/2
    factor5(4)=cos(Theta);
end 
%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
d_Thectas(i)=d_Theta;%%%%%%%

theta = Theta; 
%d_theta = d_Theta*d_varphi;

Pi = [cos(theta) -sin(theta) 0; sin(theta) cos(theta) 0; 0 0 1]; 
d_Pi = [-sin(theta) -cos(theta) 0; cos(theta) -sin(theta) 0; 0 0 0];
    %m11 = prop.m_b*norm(rho)^2 + prop.J_f + prop.J_b; 
    %m12 = (dot(prop.m_b*prop.k_hat ,cross(rho,tau)) - prop.J_b/prop.R)*d_s;
    %m21 = m12; 
    %m22 = (prop.m_b + prop.J_b/prop.R^2)*d_s^2; 
    %M = [m11 m12; m21 m22];
    
    %c11 = dot(prop.m_b*d_s*rho,tau*d_varphi); %%because w=0
    %c12 = dot(prop.m_b*d_s*rho,tau*d_theta)+d_varphi*((dot(prop.m_b*prop.k_hat ,cross(rho,tau))-prop.J_b/prop.R)*dd_s+dot(prop.m_b*prop.k_hat ,cross(rho,kappa))*d_s^2); 
    %c21 = -dot(prop.m_b*d_s*rho,tau*d_theta); 
    %c22 = (prop.m_b+prop.J_b/prop.R^2)*d_s*dd_s*d_varphi; 
    %C = [c11 c12; c21 c22];
    g1 = dot(prop.m_b*prop.grav ,d_Pi*rho); 
    g2 = dot(prop.m_b*prop.grav ,Pi*tau*d_s); 
    G = [g1;g2];

    m11 = prop.m_b*norm(rho)^2 + prop.J_f + prop.J_b; 
    m12 = (dot(prop.m_b*prop.k_hat ,cross(rho,tau)) + prop.J_b*p)*d_s; 
    m21 = m12; 
    m22 = (prop.m_b + prop.J_b*p^2)*d_s^2; 
    M = [m11 m12; m21 m22];
    
    %c11 = dot(prop.m_b*d_s*rho,tau*d_varphi); 
    %c12 = dot(prop.m_b*d_s*rho,tau*d_theta)+d_varphi*((dot(prop.m_b*prop.k_hat ,cross(rho,tau))+prop.J_b*p)*dd_s + dot(prop.m_b*prop.k_hat ,cross(rho,kappa))*d_s^2); 
    %c21 = -dot(prop.m_b*d_s*rho,tau*d_theta); 
    %c22 = (prop.m_b+prop.J_b*p^2)*d_s*dd_s*d_varphi; 
   % C = [c11 c12; c21 c22];
    
    %g1 = dot(prop.m_b*prop.grav ,d_Pi*rho); 
    %g2 = dot(prop.m_b*prop.grav ,Pi*tau*d_s); 
    %G = [g1;g2];
    
    Alpha = m21*d_Theta + m22; 
    %Beta =  m21*dd_Theta-dot(prop.m_b*d_s*rho,tau)*d_Theta+(prop.m_b+prop.J_b/prop.R^2)*d_s*dd_s; %caso 1
    Beta =  m21*dd_Theta-dot(prop.m_b*d_s*rho,tau)*d_Theta^2+(prop.m_b+prop.J_b*p^2)*d_s*dd_s; %caso 2
    %Beta1 = m21*dd_Theta; 
    %Beta2 = c21*d_Theta + c22; %split to avoid dividing by d_varphi 
    Gamma = g2;
    
    d_ThectasINV(i)=-m22/m12;
    Alphas(i)=Alpha;
    Betas(i)=Beta;
    Gammas(i)=Gamma;
    factor1(i)=Gamma/Alpha;
    factor2(i)=Beta/Alpha;
    factor3(i)=(prop.a-5*prop.b)/(prop.a-prop.b);
    factor4(i)=(prop.a+5*prop.b)/(prop.a+prop.b);
    
end
subplot (2,2,1), plot(varphis,Alphas), subplot (2,2,2), plot(varphis,d_Thectas); 
hold on 
plot(varphis,d_ThectasINV) 

subplot (2,2,3), plot(varphis,factor1);
hold on 
plot(varphis,factor2)

subplot (2,2,4), plot(varphis,factor3);
hold on 
plot (varphis,factor4);
hold on 
plot(varphis,d_Thectas);
%%%INVENTADO

